/*****************************************************************************
  // Hardware: ESP8266 Thing Dev by Sparkfun
  ESP8266 is connected to the Adafruit Feather 32u4 LoRa by means of SoftwareSerial in order to collect data coming from
  that board.
  ESP8266 is connected to a WiFi network and transfer data to the  Exosite server https://portals.exosite.com

  Wiring between Feather and ESP8266
     Feather           ESP8266
     GND                 GND
     5                    4
     6                    0
   
     Sketch parts to be set before download
     1) Set the transmitter number as ID1, ID2...IDx
     2) Complete the function Conf_http_IDx for the appropriate transmitter
     3) Set network name (SSID) and password for the WiFi in the function ConfigWiFi.h
     4) Set the PAYLOAD_LEN constant with the right length
     5) Set Exosite portal

     Library other than Arduino
     https://github.com/ekstrand/ESP8266wifi
     https://github.com/exosite-garage/arduino_exosite_library

     WARNING:  When you upload a sketch to ESP8266, be aware to disconnect serial connection to Feather board.

     Paolo Bonelli 13/07/2017  aggiunta variabile "numero progressivo" nell'invio al server. Il n. messaggio proveniente
     da Feather TX 
     Paolo Bonelli 01/08/2017  Cambiata parte ricezione dati su seriale, cambiata scheda Hardware
     Paolo Bonelli 22/11/2017  Cambiato CIK per exosite, dati inviati su altro portale Exosite
     Paolo Bonelli 17/12/2017  Inserita scheda ID8 e aggiornata scheda TX_data.h
     Paolo Bonelli 15/03/2018  Inserita scheda ID9 e aggiornata scheda TX_data.h per sensore Cafaggiolo
     Paolo Bonelli 23/03/2018  Variante alla scheda ID4 per LoRa Pluvio (modifica allo sketch di TX)
     Paolo Bonelli 28/03/2018  Adattato al workshop di Messina
*/
#include <ESP8266WiFi.h>
#include <Exosite.h>
#include <SoftwareSerial.h>
#include "ConfigWiFi.h"
#define LED_PIN 5 //LED PIN  It works on the contrary: LOW means switched on
#include "TX_data.h"

String TotalString = " ";  // String to be sent to the exosite portal
String readString = " ";  // String needed to ask the portal
String returnString;      // String issued by the portal
byte buono = 0;
///////////////////////////////////////////////////////////
#define PAYLOAD_LEN 50  // valore massimo
///////////////////////////////////////////////////////////
byte received[PAYLOAD_LEN];
byte i =       0;
byte primo =   0;
byte val =     0;
word vBatTX =  0;
word npacket = 0;
word Length=   0;
word ID_TX=    0;
byte nbyte =   0;

///////////////////////////////////////////////////////////////////////////////
byte ECHO = 1;  //  1: you can see serial output; 0: you can't. Use 0 when no USB cable is connected
////////////////////////////////////////////////////////////////////////////////
byte TrasmettiExosite = 1; // se 0 non trasmette su Exosite
/////////////////////////////////////////////////////////////////////////////////
SoftwareSerial mySerial1(0, 4); // RX, TX
WiFiClient client;
Exosite exosite(cikData, &client);
///////////////////////////////////////////////////////
void setup() {
  pinMode(0, INPUT);
  pinMode(4, OUTPUT);
  pinMode(LED_PIN, OUTPUT);

  if (ECHO) {
    Serial.begin(115200);
    delay(1000);
  }

  mySerial1.begin(57600);
  delay(1000);
  connectWifi();
  delay(2000);
  if (ECHO) {
    Serial.println("ESP_exosite_General_V7_Messina_4.ino");
    delay(1000);
    Serial.println(" Ho finito il setup ");
  }
}
/////////////////////////////////////////////////////////
void loop() {
  if(mySerial1.available() > 0){
    byte primo = mySerial1.read();
    if(primo == '$' ){
      
      if(ECHO){
      Serial.println("trovato");
      }
      
      i = 0;
      while(i < 4){
        while(mySerial1.available()== 0){}
        received[i]=mySerial1.read();      
        i++;
      }
      ID_TX = word(received[0],received[1]);
      Length = word(received[2],received[3]);
      i = 4;
      while(i < Length){
        while(mySerial1.available()== 0){}
        received[i]=mySerial1.read();      
        i++;
      }
      trasmetti();   // trasmette su WiFi
      ID_TX = 0;
      buono = 0;
      npacket = 0;
      
//  azzera tutto
      for(i = 0; i < PAYLOAD_LEN; i++){
            received[i]=0;
      }
      i=0;      
    }
   }
}








